unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    TreeView1: TTreeView;
    ListView1: TListView;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses  shellapi;
{$R *.DFM}

function SelectedPath(tr: TTreeNode):string;
begin
  result := tr.text;
  if tr.Parent <> nil then
    result := SelectedPath(tr.parent)+'\'+result; //Rekursiv
end;

function attr_(at: integer): string;
begin if at < 0 then exit;
  result := '';
  if at and 1 = 1 then result := result + 'R';
  if at and 2 = 2 then result := result + 'H';
  if at and 4 = 4 then result := result + 'S';
  if at and 8 = 8 then result := result + '(LW)';
  if at and 64 = 64 then result := result + '(64)';
  if at and 128 = 128 then result := result + '(128)';
end;



procedure Listview1itemsadd(const name, groesse, alt, attr: string);
var Newitem: TListItem;
  Info: TSHFileInfo; //uses  shellapi;
Begin
  NewItem := Form1.ListView1.Items.Add;
  NewItem.Caption := name;
  newItem.subitems.add(groesse);
  newItem.subitems.add(alt);
  Newitem.subitems.Add(attr);
  //if pos('\', name) = 0 then NewItem.ImageIndex := -1 else
    Begin
      SHGetFileInfo(PChar(name), 0, Info, SizeOf(TSHFileInfo),
      SHGFI_SYSIconIndex or SHGFI_TYPENAME);
      NewItem.ImageIndex := Info.IIcon;
    End;
end;

procedure VerzeichnisEinlesen(dir:string);
    var SR   : TSearchRec;
        pfad : String;
begin
  if dir[length(dir)]<>'\' then
    dir:=dir+'\';
  with Form1 do begin
    if FindFirst(dir+'*.*',faAnyFile,SR)=0 then Begin
      repeat
        if SR.Name[1]<>'.' then Begin
          pfad := LowerCase(dir + sr.Name);
          Listview1itemsadd(pfad,formatFloat('### ### ###',sr.size),
                            DateToStr(sr.time),attr_(sr.attr));
        End;
      until FindNext(SR)<>0;
      FindClose(SR); //Nach jedem findfirst ntig, um sr freizugeben!
    End;
  end;
end;


procedure Verzeichnisstruktur_Einlesen(Tree : TTreeView;
                                 Verzeichnis : String;
                                 Eintrag : TTreeNode);
Var SR          : TSearchRec;
    EintragTemp : TTreeNode;
    pu          : Tstringlist;
    k           : integer;
begin
  if Verzeichnis[length(Verzeichnis)]<>'\' then
    Verzeichnis:=Verzeichnis+'\';
  //Zuerst kommmen die Eintrge _sortiert_ in den Pu_ffer
  pu := Tstringlist.Create;
  pu.Sorted := true;
  try
    if FindFirst(Verzeichnis+ '*.*', faDirectory, SR)=0 then begin
      repeat
        if (SR.Attr and faDirectory = faDirectory)
          and (SR.Name[1] <> '.') then Begin
            //Eintrag ist ein Verzeichnis
            if (SR.Attr and faDirectory > 0) then pu.Add(sr.name);
        End;
      until FindNext(SR)<>0;
      FindClose(SR); //Nach jedem findfirst
    end;
   //Jetzt werden die Eintrge vom Pu_ffer in treeview1 geschaufelt.
   Tree.Items.BeginUpdate;
    for k := 0 to pu.Count -1  do Begin
     EintragTemp := Tree.Items.AddChild(Eintrag, pu[k]);
     Verzeichnisstruktur_Einlesen(Tree,Verzeichnis + pu[k], EintragTemp); //rekursiv}
    End;
    Tree.Items.EndUpdate;
  Finally pu.Free End;
end; {Nach Michael Geisler in Simon Reinhards FAQ}

procedure InitialisiereIcons;
  var SysIL         : uint;
        SFI         : TSHFileInfo;
        SmallImages : TImageList;
begin
  SmallImages := TImageList.Create(Form1);
  SysIL := SHGetFileInfo('', 0, SFI, SizeOf(SFI),
            SHGFI_SYSICONINDEX or SHGFI_SMALLICON);
  if SysIL <> 0 then Begin
    SmallImages.Handle := SysIL;
    SmallImages.ShareImages := TRUE;
  End;
  Form1.ListView1.SmallImages := SmallImages;
end;

procedure TForm1.FormCreate(Sender: TObject);
  var  NewColumn: TListColumn;
begin
   button1.Top := 0;
   form1.setbounds(0,0,screen.Width,screen.height);
   treeview1.setbounds(0,button1.height,screen.width div 5 - 15,
                       screen.height - button1.height - 30);
   listview1.setbounds(treeview1.width,button1.height,4*screen.Width div 5 - 15,
                       treeview1.height);
   listview1.ViewStyle := vsReport;
   listview1.GridLines := true;
   with listview1 do Begin
     NewColumn := Columns.Add;
     NewColumn.Caption := 'Pfad';
     newColumn.Width := listview1.Width div 3;
     NewColumn := Columns.Add;
     NewColumn.Caption := 'Gre';
     newColumn.Width := listview1.Width div 6;
     NewColumn := Columns.Add;
     NewColumn.Caption := 'Datum';
     newColumn.Width :=  listview1.Width div 6;
     NewColumn := Columns.Add;
     NewColumn.Caption := 'Attr';
     newColumn.Width :=  listview1.Width div 12;
   End;
   InitialisiereIcons;
end;

procedure TForm1.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
  listview1.Items.Clear;
  VerzeichnisEinlesen(SelectedPath(treeview1.selected));
end;

procedure TForm1.Button1Click(Sender: TObject);
  var   Eintrag : TTreeNode;
        verz    : String;
begin
  verz := 'c:';
  TreeView1.Items.Clear;
  Eintrag := TreeView1.Items.Add(nil,verz);
  Verzeichnisstruktur_Einlesen(TreeView1,verz,eintrag);
  Eintrag.Expand(false); //verz. wird geffnet
end;


end.



